"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ERC20Contract = void 0;
const objects_1 = require("@hypernetlabs/objects");
const ethers_1 = require("ethers");
const neverthrow_1 = require("neverthrow");
class ERC20Contract {
    constructor(providerOrSigner, contractAddress) {
        this.contract = null;
        this.contract = new ethers_1.ethers.Contract(contractAddress, objects_1.GovernanceAbis.Hypertoken.abi, providerOrSigner);
    }
    approve(registryAddress, registrationFee) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.approve(registryAddress, registrationFee), (e) => {
            return new objects_1.ERC20ContractError("Unable to call hypertokenContract approve()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.ERC20ContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    delegate(delegateAddress) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.delegate(delegateAddress), (e) => {
            return new objects_1.ERC20ContractError("Unable to call hypertokenContract delegate()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.ERC20ContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    balanceOf(account) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.balanceOf(account), (e) => {
            return new objects_1.ERC20ContractError("Unable to call HypernetGovernorContract balanceOf()", e);
        });
    }
    getVotes(account) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.getVotes(account), (e) => {
            return new objects_1.ERC20ContractError("Unable to call HypernetGovernorContract getVotes()", e);
        });
    }
}
exports.ERC20Contract = ERC20Contract;
//# sourceMappingURL=ERC20Contract.js.map