import { BigNumberString, EthereumContractAddress, ERC20ContractError, EthereumAccountAddress } from "@hypernetlabs/objects";
import { BigNumber, ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { IERC20Contract } from "../../interfaces/utilities";
export declare class ERC20Contract implements IERC20Contract {
    protected contract: ethers.Contract | null;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner, contractAddress: EthereumContractAddress);
    approve(registryAddress: EthereumContractAddress, registrationFee: BigNumberString): ResultAsync<void, ERC20ContractError>;
    delegate(delegateAddress: EthereumAccountAddress): ResultAsync<void, ERC20ContractError>;
    balanceOf(account: EthereumAccountAddress): ResultAsync<BigNumber, ERC20ContractError>;
    getVotes(account: EthereumAccountAddress): ResultAsync<BigNumber, ERC20ContractError>;
}
//# sourceMappingURL=ERC20Contract.d.ts.map