"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NonFungibleRegistryEnumerableUpgradeableContract = void 0;
const objects_1 = require("@hypernetlabs/objects");
const ethers_1 = require("ethers");
const neverthrow_1 = require("neverthrow");
class NonFungibleRegistryEnumerableUpgradeableContract {
    constructor(providerOrSigner, registryAddress) {
        this.contract = null;
        this.contract = new ethers_1.ethers.Contract(registryAddress, objects_1.GovernanceAbis.NonFungibleRegistryEnumerableUpgradeable.abi, providerOrSigner);
    }
    getContractAddress() {
        var _a;
        return (0, objects_1.EthereumContractAddress)(((_a = this.contract) === null || _a === void 0 ? void 0 : _a.address) || "");
    }
    getRegistrarRoleMemberCount() {
        var _a, _b;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.getRoleMemberCount((_b = this.contract) === null || _b === void 0 ? void 0 : _b.REGISTRAR_ROLE()), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call getRoleMemberCount REGISTRAR_ROLE", e);
        });
    }
    getRegistrarRoleMember(index) {
        var _a, _b;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.getRoleMember((_b = this.contract) === null || _b === void 0 ? void 0 : _b.REGISTRAR_ROLE(), index || 0), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call getRoleMember REGISTRAR_ROLE", e);
        });
    }
    getRegistrarRoleAdminMemberCount() {
        var _a, _b;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.getRoleMemberCount((_b = this.contract) === null || _b === void 0 ? void 0 : _b.REGISTRAR_ROLE_ADMIN()), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call getRegistrarRoleAdminMemberCount REGISTRAR_ROLE_ADMIN", e);
        });
    }
    getRegistrarRoleAdminMember(index) {
        var _a, _b;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.getRoleMember((_b = this.contract) === null || _b === void 0 ? void 0 : _b.REGISTRAR_ROLE_ADMIN(), index || 0), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call getRegistrarRoleAdminMember REGISTRAR_ROLE_ADMIN", e);
        });
    }
    name() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.name(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call name()", e);
        });
    }
    symbol() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.symbol(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call symbol()", e);
        });
    }
    totalSupply() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.totalSupply(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call totalSupply()", e);
        }).map((totalSupply) => totalSupply.toNumber());
    }
    allowLazyRegister() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.allowLazyRegister(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call allowLazyRegister()", e);
        });
    }
    allowStorageUpdate() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.allowStorageUpdate(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call allowStorageUpdate()", e);
        });
    }
    allowLabelChange() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.allowLabelChange(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call allowLabelChange()", e);
        });
    }
    allowTransfers() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.allowTransfers(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call allowTransfers()", e);
        });
    }
    registrationToken() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.registrationToken(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call registrationToken()", e);
        });
    }
    registrationFee() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.registrationFee(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call registrationFee()", e);
        }).map((fee) => {
            return (0, objects_1.BigNumberString)(ethers_1.ethers.utils.formatUnits(fee, "ether"));
        });
    }
    burnAddress() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.burnAddress(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call burnAddress()", e);
        });
    }
    burnFee() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.burnFee(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call burnFee()", e);
        }).map((fee) => {
            return fee.toNumber();
        });
    }
    primaryRegistry() {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.primaryRegistry(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call primaryRegistry()", e);
        });
    }
    tokenByIndex(index) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.tokenByIndex(index), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call tokenByIndex()", e);
        }).map((tokenId) => tokenId.toNumber());
    }
    reverseRegistryMap(tokenId) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.reverseRegistryMap(tokenId), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call reverseRegistryMap()", e);
        });
    }
    ownerOf(tokenId) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.ownerOf(tokenId), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call ownerOf()", e);
        });
    }
    tokenURI(tokenId) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.tokenURI(tokenId), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call tokenURI()", e);
        });
    }
    updateRegistration(tokenId, registrationData) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.updateRegistration(ethers_1.BigNumber.from(tokenId), registrationData), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call updateRegistration()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    updateLabel(tokenId, label) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.updateLabel(ethers_1.BigNumber.from(tokenId), label), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call updateLabel()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    transferFrom(tokenId, ownerAddress, toAddress) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.transferFrom(ownerAddress, toAddress, tokenId), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call transferFrom()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    burn(tokenId) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.burn(tokenId), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call burn()", e);
        }).map(() => { });
    }
    setRegistryParameters(params) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.setRegistryParameters(params), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call setRegistryParameters()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    registerByToken(recipientAddress, label, data) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.registerByToken(recipientAddress, label, data), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call registerByToken()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    register(recipientAddress, label, data) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.register(recipientAddress, label, data), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call register()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    grantRole(address) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.REGISTRAR_ROLE(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call REGISTRAR_ROLE", e);
        })
            .andThen((registrarRole) => {
            var _a;
            return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.grantRole(registrarRole, address), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to call grantRole", e);
            });
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map((val) => { });
    }
    revokeRole(address) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.REGISTRAR_ROLE(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call REGISTRAR_ROLE", e);
        })
            .andThen((registrarRole) => {
            var _a;
            return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.revokeRole(registrarRole, address), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to call revokeRole", e);
            });
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
    renounceRole(address) {
        var _a;
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.REGISTRAR_ROLE(), (e) => {
            return new objects_1.NonFungibleRegistryContractError("Unable to call REGISTRAR_ROLE", e);
        })
            .andThen((registrarRole) => {
            var _a;
            return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.renounceRole(registrarRole, address), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to call renounceRole", e);
            });
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.NonFungibleRegistryContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
}
exports.NonFungibleRegistryEnumerableUpgradeableContract = NonFungibleRegistryEnumerableUpgradeableContract;
//# sourceMappingURL=NonFungibleRegistryEnumerableUpgradeableContract.js.map